/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By: $B2#ED(B $BM5;W(B <y5t0964@students.chiba-u.ac.jp>
 */


/* Type1_16.h */

#ifndef _TYPE1_16_H
#define _TYPE1_16_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>

#include <X11/Xos.h>

#define XtNumber(arr) ((unsigned int) (sizeof(arr) / sizeof(arr[0])))

#include "fntfilst.h"

#include "Type1_16struct.h"
#include "tree.h"
#include "metric.h"

#define T1_16_EXT      ".atm"
#define T1_16_EXT_LEN  4

#define T1_16_EXT_I      ".atm-i"
#define T1_16_EXT_LEN_I  6


Bool FontFileRegisterRenderer (FontRendererPtr renderer);
void BitOrderInvert(register unsigned char *buf, register int nbytes);
void TwoByteSwap(register unsigned char *buf, register int nbytes);
void FourByteSwap(register unsigned char *buf, register int nbytes);
int CheckFSFormat(fsBitmapFormat format,
		  fsBitmapFormatMask fmask,
		  int *bit_order,
		  int *byte_order,
		  int *scan,
		  int *glyph,
		  int *image);
Atom MakeAtom(char *string, unsigned len, int makeit);
int FontDefaultFormat (int *bit, int *byte, int *glyph, int *scan);
            /* $B$3$N4X?t$O(B void $B7?$K8+$($k$N$@$,(B... -> fontfile/defaults.c */

/* $B$3$l$i$N4X?t$O<B:]$NDj5A$H0c$&$,(B, $B@5$7$/F0$/$O$:(B */
void *Xalloc (int m);
void *Xrealloc (void *n, int m);
void Xfree (void *n);



/* fcntl.c */
void _nonblock(int fd);
void _block(int fd);
void _flush(int fd);

/* string_ut.c */
char * strcasestr(char *haystack, const char *needle);

/* pool.c */
CharInfoPoolPtr CharInfoPool_Alloc(int bitmapSize);
CharInfoPtr CharInfoPool_Get(CharInfoPoolPtr this);
void CharInfoPool_Free(CharInfoPoolPtr this);

/* Type1_16funcs.c */
int Type1_16OpenScalable(FontPathElementPtr fpe,
			 FontPtr	    *pFont,
			 int                flags,
			 FontEntryPtr       entry,
			 char               *fileName,
			 FontScalablePtr    vals,
			 fsBitmapFormat     format,
			 fsBitmapFormatMask fmask,
			 FontPtr            non_cachable_font);
int Type1_16GetInfoScalable(FontPathElementPtr  fpe,
			    FontInfoPtr	        pFontInfo,
			    FontEntryPtr        entry,
			    FontNamePtr	        pFontName,
			    char	        *fileName,
			    FontScalablePtr	vals);
void Type1_16RegisterFontFileFunctions(void);


/* gs.c */
void gsInit(nodeptr np);
void gsDeinit(nodeptr np);
void t1_16_gs_quit(int i);

/* italic.c */
int Type1_16OpenScalable_italic(FontPathElementPtr fpe,
				FontPtr	           *pFont,
				int                flags,
				FontEntryPtr       entry,
				char               *fileName,
				FontScalablePtr    vals,
				fsBitmapFormat     format,
				fsBitmapFormatMask fmask,
				FontPtr            non_cachable_font);
int Type1_16GetInfoScalable_italic(FontPathElementPtr  fpe,
				   FontInfoPtr	       pFontInfo,
				   FontEntryPtr        entry,
				   FontNamePtr	       pFontName,
				   char	               *fileName,
				   FontScalablePtr     vals);

#endif
