/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By: $B2#ED(B $BM5;W(B <y5t0964@students.chiba-u.ac.jp>
 */

/* gs.c -- ghostscript $B$N@)8f(B */
/* $Id: gs.c,v 1.2 1998/03/30 05:41:39 elca Exp $ */

#include "Type1_16.h"
#include "tree.h"

/*#define dprintf(str) fprintf str*/
#define dprintf(str) /* */

/* ghostscript $B$N5/F0$H=i4|2=(B */
void gsInit(nodeptr ptr)
{
	dprintf((stdout, "gsinit\n"));

	/* ghostscript $B$H$NDL?.@~$r:n$k(B */
	if(pipe(ptr->gs[0]) != 0) {
		printf("gs[0] pipe error\n");
		exit(1);
	}
	if(pipe(ptr->gs[1]) != 0) {
		printf("gs[1] pipe error\n");
		exit(1);
	}
	switch(ptr->gsPid = fork()) {
	case -1:
		printf("fork gs error\n");
		exit(1);
		break;
	case 0:
		/* gs -> xfs $B$X$NDL?.@~$r:n$k(B */
		close(STDIN_FILENO);
		dup(ptr->gs[0][0]);
		close(STDOUT_FILENO);
		dup(ptr->gs[1][1]);

		close(ptr->gs[0][0]);
		close(ptr->gs[0][1]);
		close(ptr->gs[1][0]);
		close(ptr->gs[1][1]);

		/* ghostscript $B5/F0(B */
		/* gs -dSAFER -sDEVICE=bit -sOutputFile=- -q -dNOPAUSE
		    -dNOPAUSE -g32x16
		    -c "/.setpagesize { //systemdict /statusdict get begin .setpagesize end } bind def"
		    - */
		execlp("gs", "gs", "-dSAFER", "-sDEVICE=bit", "-sOutputFile=-",
		       "-q", "-dNOPAUSE", "-c",
		       "/.setpagesize { //systemdict /statusdict get begin .setpagesize end } bind def",
		       "-", NULL);
		printf("execlp gs error\n");
		exit(1);
	default:
		/* xfs -> gs $B$X$NDL?.@~0J30$O:o=|(B */
		close(ptr->gs[0][0]);
		close(ptr->gs[1][1]);
		break;
	}

	_nonblock(ptr->gs[1][0]);

}

/* ghostscript $B$r=*N;$5$;$k(B */
void gsDeinit(nodeptr ptr)
{
	_flush(ptr->gs[1][0]);

	dprintf((stdout, "gsquit\n"));

	write(ptr->gs[0][1], "quit\n", strlen("quit\n"));

	/* $BDL?.@~$rJD$8$k(B */
	close(ptr->gs[0][1]);
	close(ptr->gs[1][0]);
}

/* $B%7%0%J%k%O%s%I%i(B */
void t1_16_gs_quit(int i)
{
	int status;

	dprintf((stdout, "sigcld %d\n", i));
	wait(&status);
}

/* end */
