/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By: $B2#ED(B $BM5;W(B <y5t0964@students.chiba-u.ac.jp>
 */

/* italic.c $B%$%?%j%C%/BN@8@.5!G=(B */
/* $Id: italic.c,v 1.3 1998/04/04 08:43:31 elca Exp $ */

#include "Type1_16.h"

/*#define dprintf(str) fprintf str */
#define dprintf(str) /* */

int Type1_16OpenScalable_italic(FontPathElementPtr fpe,
				FontPtr	           *pFont,
				int                flags,
				FontEntryPtr       entry,
				char               *fileName,
				FontScalablePtr    vals,
				fsBitmapFormat     format,
				fsBitmapFormatMask fmask,
				FontPtr            non_cachable_font) /* We don't do licensing */
{
	int ret;
	int pos;
	char *save_entryfileName;
	char *save_fileName;
	double save_pixel_matrix_2;
	double save_point_matrix_2;
	char entryfileName[MAXFONTFILENAMELEN];
	char fontName[MAXFONTFILENAMELEN];

	/* $BCM$N%P%C%/%"%C%W(B */
	save_entryfileName = entry->u.scalable.fileName;
	save_fileName = fileName;
	save_pixel_matrix_2 = vals->pixel_matrix[2];
	save_point_matrix_2 = vals->point_matrix[2];


	strcpy(entryfileName, entry->u.scalable.fileName);
	pos = strlen(entryfileName) - (T1_16_EXT_LEN_I - T1_16_EXT_LEN);
	if (pos <= 0) {
		return BadFontName;
	}
	entryfileName[pos] = '\0';
	strcpy(fontName, fileName);
	pos = strlen(fontName) - (T1_16_EXT_LEN_I - T1_16_EXT_LEN);
	if (pos <= 0) {
		return BadFontName;
	}
	fontName[pos] = '\0';

	/* $BCM$N=q$-49$((B */
	entry->u.scalable.fileName = entryfileName;
	fileName = fontName;
	vals->pixel_matrix[2] += vals->pixel_matrix[3] * 0.25;
	vals->point_matrix[2] += vals->point_matrix[3] * 0.25;

	dprintf((stdout, "%s %s\n", entry->u.scalable.fileName, fileName));

	ret = Type1_16OpenScalable(fpe, pFont, flags, entry,
				    fileName, vals, format, fmask,
				    non_cachable_font);

	/* $B%P%C%/%"%C%W$NI|85(B */
	entry->u.scalable.fileName = save_entryfileName;
	fileName = save_fileName;
	vals->pixel_matrix[2] = save_pixel_matrix_2;
	vals->point_matrix[2] = save_point_matrix_2;

	return ret;
}

int Type1_16GetInfoScalable_italic(FontPathElementPtr  fpe,
				   FontInfoPtr	       pFontInfo,
				   FontEntryPtr        entry,
				   FontNamePtr	       pFontName,
				   char	               *fileName,
				   FontScalablePtr     vals)
{
	FontPtr pfont;
	int flags = 0;
	long format = 0;  /* It doesn't matter what format for just info */
	long fmask = 0;
	int ret;

	dprintf((stderr, "\nType1_16GetInfoScalable_italic(%x, %x, %x, %x, %s, %x)\n",
		 fpe, pFontInfo, entry, fontName, fileName, vals));

	ret = Type1_16OpenScalable_italic(fpe, &pfont, flags, entry, fileName, vals,
					  format, fmask, NULL);
	if (ret != Successful)
		return ret;
	*pFontInfo = pfont->info;

	(*pfont->unload_font)(pfont);

	return Successful;
}

/* end */
